using System;
using System.ComponentModel;
using System.Collections;
using Borland.Eco.Services;
using Borland.Eco.ObjectRepresentation;
using Borland.Eco.ObjectImplementation;
using Borland.Eco.UmlRt;
using Borland.Eco.UmlCodeAttributes;


namespace ECOSample1
{
	[UmlCollection(typeof(WorkItem))][EcoAutoGenerated]
	public interface IWorkItemList
	{
		
		WorkItem this[int index] {get; set;}
		int Count
		{
			get;
		}
		
		void Clear();
		
		void RemoveAt(int index);
		
		int Add(WorkItem value);
		
		bool Contains(WorkItem value);
		
		int IndexOf(WorkItem value);
		
		void Insert(int index, WorkItem value);
		
		void Remove(WorkItem value);
	}
	[UmlCollection(typeof(Project))][EcoAutoGenerated]
	public interface IProjectList
	{
		
		Project this[int index] {get; set;}
		int Count
		{
			get;
		}
		
		void Clear();
		
		void RemoveAt(int index);
		
		int Add(Project value);
		
		bool Contains(Project value);
		
		int IndexOf(Project value);
		
		void Insert(int index, Project value);
		
		void Remove(Project value);
	}
	[UmlCollection(typeof(Task))][EcoAutoGenerated]
	public interface ITaskList
	{
		
		Task this[int index] {get; set;}
		int Count
		{
			get;
		}
		
		void Clear();
		
		void RemoveAt(int index);
		
		int Add(Task value);
		
		bool Contains(Task value);
		
		int IndexOf(Task value);
		
		void Insert(int index, Task value);
		
		void Remove(Task value);
	}
	[UmlElement("Package")]
	[EcoCodeGenVersion("1.0")]
	[UmlMetaAttribute("ownedElement", typeof(Task))]
	[UmlMetaAttribute("ownedElement", typeof(Project))]
	[UmlMetaAttribute("ownedElement", typeof(WorkItem))]
	public abstract class CoreClassesPackage
	{
		
		[UmlElement("Association")]
		public class Association_1
		{
		}
		
		[UmlElement("Association")]
		public class Association_2
		{
		}
		
		[UmlElement("Association")]
		public class Association_3
		{
		}
	}
	[UmlElement]
	public class Task : object, ILoopBack
	{
		
		[EcoAutoGenerated]
		public class TaskListAdapter : ObjectListAdapter, ITaskList
		{
			
			public Task this[int index] {get {return (Task)Adaptee[index];} set {Adaptee[index] = value;}}
			public TaskListAdapter(IList source) : 
					base(source)
			{
			}
			
			public int Add(Task value)
			{
				return this.Adaptee.Add(value);
			}
			
			public bool Contains(Task value)
			{
				return this.Adaptee.Contains(value);
			}
			
			public int IndexOf(Task value)
			{
				return this.Adaptee.IndexOf(value);
			}
			
			public void Insert(int index, Task value)
			{
				this.Adaptee.Insert(index, value);
			}
			
			public void Remove(Task value)
			{
				this.Adaptee.Remove(value);
			}
		}
		
		#region Autogenerated ECO code
		
		[EcoAutoGenerated]
		public IObject AsIObject()
		{
			return this._content.AsIObject();
		}
		[EcoAutoGenerated]
		protected IContent _content;
		
		[EcoAutoGenerated]
		public Task(IContent content)
		{
			this._content = content;
		}
		[EcoAutoGenerated]
		protected internal const int TaskFirstMember = 0;
		[EcoAutoGenerated]
		protected internal const int TaskMemberCount = (Task.TaskFirstMember + 7);
		
		[EcoAutoGenerated]
		protected String _Name
		{
			get
			{
				return ((String)(this._content.get_MemberByIndex((TaskFirstMember + 0))));
			}
			set
			{
				this._content.set_MemberByIndex((TaskFirstMember + 0), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected Boolean _CollectSubWorkItems
		{
			get
			{
				return ((Boolean)(this._content.get_MemberByIndex((TaskFirstMember + 1))));
			}
			set
			{
				this._content.set_MemberByIndex((TaskFirstMember + 1), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected Boolean _SpanSubWorkItems
		{
			get
			{
				return ((Boolean)(this._content.get_MemberByIndex((TaskFirstMember + 2))));
			}
			set
			{
				this._content.set_MemberByIndex((TaskFirstMember + 2), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected IList _WorkItem
		{
			get
			{
				return ((IList)(this._content.get_MemberByIndex((TaskFirstMember + 3))));
			}
		}
		
		[EcoAutoGenerated]
		protected Project _Project
		{
			get
			{
				return ((ECOSample1.Project)(this._content.get_MemberByIndex((TaskFirstMember + 4))));
			}
			set
			{
				this._content.set_MemberByIndex((TaskFirstMember + 4), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected Task _owner
		{
			get
			{
				return ((ECOSample1.Task)(this._content.get_MemberByIndex((TaskFirstMember + 5))));
			}
			set
			{
				this._content.set_MemberByIndex((TaskFirstMember + 5), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected IList _subtasks
		{
			get
			{
				return ((IList)(this._content.get_MemberByIndex((TaskFirstMember + 6))));
			}
		}
		
		[EcoAutoGenerated]
		public virtual object get_MemberByIndex(int index)
		{
			switch(index)
            {
                case TaskFirstMember + 0:
                      return this.Name;
                case TaskFirstMember + 1:
                      return this.CollectSubWorkItems;
                case TaskFirstMember + 2:
                      return this.SpanSubWorkItems;
                case TaskFirstMember + 3:
                      return this.WorkItem;
                case TaskFirstMember + 4:
                      return this.Project;
                case TaskFirstMember + 5:
                      return this.owner;
                case TaskFirstMember + 6:
                      return this.subtasks;
                default:
                    throw new System.IndexOutOfRangeException();
            }

		}
		
		[EcoAutoGenerated]
		public virtual void set_MemberByIndex(int index, object value)
		{
			switch(index)
            {
                case TaskFirstMember + 0:
                    this.Name = (String)value;
                    break;
                case TaskFirstMember + 1:
                    this.CollectSubWorkItems = (Boolean)value;
                    break;
                case TaskFirstMember + 2:
                    this.SpanSubWorkItems = (Boolean)value;
                    break;
                case TaskFirstMember + 4:
                    this.Project = (Project)value;
                    break;
                case TaskFirstMember + 5:
                    this.owner = (Task)value;
                    break;
                default:
                    throw new System.IndexOutOfRangeException();
            }

		}
		
		[EcoAutoGenerated]
		protected void Initialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content == null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				this._content = factory.CreateContent(this);
			}
		}
		
		[EcoAutoGenerated]
		protected void Deinitialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content != null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				factory.CreateContentFailed(this._content, this);
				this._content = null;
			}
		}
		
		#endregion Autogenerated ECO code
		
		[EcoAutoMaintained]
		public Task(IEcoServiceProvider serviceProvider)
		{
			this.Initialize(serviceProvider);
			try
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
			catch (System.Exception )
			{
				this.Deinitialize(serviceProvider);
				throw;
			}
		}
		[UmlElement("AssociationEnd", Index=(Task.TaskFirstMember + 3))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.Association_1), Index=0)]
		[UmlMetaAttribute("multiplicity", "0..*")]
		[UmlMetaAttribute("aggregation", AggregationKind.Composite)]
		public IWorkItemList WorkItem
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return new ECOSample1.WorkItem.WorkItemListAdapter(this._WorkItem);
			}
		}
		[UmlElement("AssociationEnd", Index=(Task.TaskFirstMember + 4))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.Association_2), Index=1)]
		[UmlMetaAttribute("multiplicity", "0..1")]
		public Project Project
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Project;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Project = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement("AssociationEnd", Index=(Task.TaskFirstMember + 5))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.Association_3), Index=0)]
		[UmlMetaAttribute("multiplicity", "0..1")]
		public Task owner
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._owner;
			}
			set
			{
				this._owner = value;
			}
		}
		[UmlElement("AssociationEnd", Index=(Task.TaskFirstMember + 6))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.Association_3), Index=1)]
		[UmlMetaAttribute("multiplicity", "0..*")]
		[UmlMetaAttribute("aggregation", AggregationKind.Composite)]
		public ITaskList subtasks
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return new ECOSample1.Task.TaskListAdapter(this._subtasks);
			}
		}
		[UmlElement(Index=(Task.TaskFirstMember + 0))]
		[EcoAutoMaintained]
		[UmlTaggedValue("derived", "False")]
		public String Name
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Name;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Name = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(Task.TaskFirstMember + 1))]
		[EcoAutoMaintained]
		[UmlTaggedValue("derived", "False")]
		public Boolean CollectSubWorkItems
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._CollectSubWorkItems;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._CollectSubWorkItems = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(Task.TaskFirstMember + 2))]
		[EcoAutoMaintained]
		[UmlTaggedValue("derived", "False")]
		public Boolean SpanSubWorkItems
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._SpanSubWorkItems;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._SpanSubWorkItems = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
	}
	[UmlElement]
	public class Project : object, ILoopBack
	{
		
		[EcoAutoGenerated]
		public class ProjectListAdapter : ObjectListAdapter, IProjectList
		{
			
			public Project this[int index] {get {return (Project)Adaptee[index];} set {Adaptee[index] = value;}}
			public ProjectListAdapter(IList source) : 
					base(source)
			{
			}
			
			public int Add(Project value)
			{
				return this.Adaptee.Add(value);
			}
			
			public bool Contains(Project value)
			{
				return this.Adaptee.Contains(value);
			}
			
			public int IndexOf(Project value)
			{
				return this.Adaptee.IndexOf(value);
			}
			
			public void Insert(int index, Project value)
			{
				this.Adaptee.Insert(index, value);
			}
			
			public void Remove(Project value)
			{
				this.Adaptee.Remove(value);
			}
		}
		
		#region Autogenerated ECO code
		
		[EcoAutoGenerated]
		public IObject AsIObject()
		{
			return this._content.AsIObject();
		}
		[EcoAutoGenerated]
		protected IContent _content;
		
		[EcoAutoGenerated]
		public Project(IContent content)
		{
			this._content = content;
		}
		[EcoAutoGenerated]
		protected internal const int ProjectFirstMember = 0;
		[EcoAutoGenerated]
		protected internal const int ProjectMemberCount = (Project.ProjectFirstMember + 2);
		
		[EcoAutoGenerated]
		protected String _Name
		{
			get
			{
				return ((String)(this._content.get_MemberByIndex((ProjectFirstMember + 0))));
			}
			set
			{
				this._content.set_MemberByIndex((ProjectFirstMember + 0), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected IList _Task
		{
			get
			{
				return ((IList)(this._content.get_MemberByIndex((ProjectFirstMember + 1))));
			}
		}
		
		[EcoAutoGenerated]
		public virtual object get_MemberByIndex(int index)
		{
			switch(index)
            {
                case ProjectFirstMember + 0:
                      return this.Name;
                case ProjectFirstMember + 1:
                      return this.Task;
                default:
                    throw new System.IndexOutOfRangeException();
            }

		}
		
		[EcoAutoGenerated]
		public virtual void set_MemberByIndex(int index, object value)
		{
			switch(index)
            {
                case ProjectFirstMember + 0:
                    this.Name = (String)value;
                    break;
                default:
                    throw new System.IndexOutOfRangeException();
            }

		}
		
		[EcoAutoGenerated]
		protected void Initialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content == null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				this._content = factory.CreateContent(this);
			}
		}
		
		[EcoAutoGenerated]
		protected void Deinitialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content != null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				factory.CreateContentFailed(this._content, this);
				this._content = null;
			}
		}
		
		#endregion Autogenerated ECO code
		
		[EcoAutoMaintained]
		public Project(IEcoServiceProvider serviceProvider)
		{
			this.Initialize(serviceProvider);
			try
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
			catch (System.Exception )
			{
				this.Deinitialize(serviceProvider);
				throw;
			}
		}
		[UmlElement("AssociationEnd", Index=(Project.ProjectFirstMember + 1))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.Association_2), Index=0)]
		[UmlMetaAttribute("multiplicity", "0..*")]
		[UmlMetaAttribute("aggregation", AggregationKind.Composite)]
		public ITaskList Task
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return new ECOSample1.Task.TaskListAdapter(this._Task);
			}
		}
		[UmlElement(Index=(Project.ProjectFirstMember + 0))]
		[EcoAutoMaintained]
		[UmlTaggedValue("derived", "False")]
		public String Name
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Name;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Name = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
	}
	[UmlElement]
	public class WorkItem : object, ILoopBack
	{
		
		[EcoAutoGenerated]
		public class WorkItemListAdapter : ObjectListAdapter, IWorkItemList
		{
			
			public WorkItem this[int index] {get {return (WorkItem)Adaptee[index];} set {Adaptee[index] = value;}}
			public WorkItemListAdapter(IList source) : 
					base(source)
			{
			}
			
			public int Add(WorkItem value)
			{
				return this.Adaptee.Add(value);
			}
			
			public bool Contains(WorkItem value)
			{
				return this.Adaptee.Contains(value);
			}
			
			public int IndexOf(WorkItem value)
			{
				return this.Adaptee.IndexOf(value);
			}
			
			public void Insert(int index, WorkItem value)
			{
				this.Adaptee.Insert(index, value);
			}
			
			public void Remove(WorkItem value)
			{
				this.Adaptee.Remove(value);
			}
		}
		
		#region Autogenerated ECO code
		
		[EcoAutoGenerated]
		public IObject AsIObject()
		{
			return this._content.AsIObject();
		}
		[EcoAutoGenerated]
		protected IContent _content;
		
		[EcoAutoGenerated]
		public WorkItem(IContent content)
		{
			this._content = content;
		}
		[EcoAutoGenerated]
		protected internal const int WorkItemFirstMember = 0;
		[EcoAutoGenerated]
		protected internal const int WorkItemMemberCount = (WorkItem.WorkItemFirstMember + 4);
		
		[EcoAutoGenerated]
		protected DateTime _Start
		{
			get
			{
				return ((DateTime)(this._content.get_MemberByIndex((WorkItemFirstMember + 0))));
			}
			set
			{
				this._content.set_MemberByIndex((WorkItemFirstMember + 0), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected DateTime _Stop
		{
			get
			{
				return ((DateTime)(this._content.get_MemberByIndex((WorkItemFirstMember + 1))));
			}
			set
			{
				this._content.set_MemberByIndex((WorkItemFirstMember + 1), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected String _Note
		{
			get
			{
				return ((String)(this._content.get_MemberByIndex((WorkItemFirstMember + 2))));
			}
			set
			{
				this._content.set_MemberByIndex((WorkItemFirstMember + 2), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		protected Task _Task
		{
			get
			{
				return ((ECOSample1.Task)(this._content.get_MemberByIndex((WorkItemFirstMember + 3))));
			}
			set
			{
				this._content.set_MemberByIndex((WorkItemFirstMember + 3), ((object)(value)));
			}
		}
		
		[EcoAutoGenerated]
		public virtual object get_MemberByIndex(int index)
		{
			switch(index)
            {
                case WorkItemFirstMember + 0:
                      return this.Start;
                case WorkItemFirstMember + 1:
                      return this.Stop;
                case WorkItemFirstMember + 2:
                      return this.Note;
                case WorkItemFirstMember + 3:
                      return this.Task;
                default:
                    throw new System.IndexOutOfRangeException();
            }

		}
		
		[EcoAutoGenerated]
		public virtual void set_MemberByIndex(int index, object value)
		{
			switch(index)
            {
                case WorkItemFirstMember + 0:
                    this.Start = (DateTime)value;
                    break;
                case WorkItemFirstMember + 1:
                    this.Stop = (DateTime)value;
                    break;
                case WorkItemFirstMember + 2:
                    this.Note = (String)value;
                    break;
                case WorkItemFirstMember + 3:
                    this.Task = (Task)value;
                    break;
                default:
                    throw new System.IndexOutOfRangeException();
            }

		}
		
		[EcoAutoGenerated]
		protected void Initialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content == null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				this._content = factory.CreateContent(this);
			}
		}
		
		[EcoAutoGenerated]
		protected void Deinitialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content != null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				factory.CreateContentFailed(this._content, this);
				this._content = null;
			}
		}
		
		#endregion Autogenerated ECO code
		
		[EcoAutoMaintained]
		public WorkItem(IEcoServiceProvider serviceProvider)
		{
			this.Initialize(serviceProvider);
			try
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
			catch (System.Exception )
			{
				this.Deinitialize(serviceProvider);
				throw;
			}
		}
		[UmlElement("AssociationEnd", Index=(WorkItem.WorkItemFirstMember + 3))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.Association_1), Index=1)]
		[UmlMetaAttribute("multiplicity", "0..1")]
		public Task Task
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Task;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Task = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(WorkItem.WorkItemFirstMember + 0))]
		[EcoAutoMaintained]
		[UmlTaggedValue("derived", "False")]
		public DateTime Start
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Start;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Start = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(WorkItem.WorkItemFirstMember + 1))]
		[EcoAutoMaintained]
		[UmlTaggedValue("derived", "False")]
		public DateTime Stop
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Stop;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Stop = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(WorkItem.WorkItemFirstMember + 2))]
		[EcoAutoMaintained]
		[UmlTaggedValue("derived", "False")]
		public String Note
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Note;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Note = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
	}
}
